mdspass2 インストールマニュアル

１．必要な開発環境やライブラリのインストール

<Linuxの場合>

１）freeglut のインストール
freeglut と freeglut-devel のパッケージがインストールされている必要があります。
CentOSなどyumによるパッケージ管理の環境では
> sudo yum install freeglut
> sudo yum install freeglut-devel
ubuntuなどのaptによるパッケージ管理環境では
> sudo apt install freeglut3-dev

２）glui のインストール
glui は http://glui.sourceforge.net/ より入手可能。
glui-2.36.tgz をダウンロード、コンパイル。
　srcディレクトリに行き、makefileを修正
　(2)FreeGLUTと書いてある場所の下の2行のコメントアウトを外し、
    /usr/X11R6/lib -lfreeglut を /usr/lib -lglut に、
    /usr/X11R6/include を /usr/include に直す。
  (3)GLUTの下の2行をコメントアウト。
make し、所定の場所に libglui.a と glui.h をコピー。
私の環境では、
 /usr/lib/libglui.a
 /usr/include/GL/glui.h

※なお，GLUIにはファイルブラウザで、ダブルクリックが効かない／ディレクトリが
変更できない／一番トップに表示されるファイルが選択できない／ファイル名が
アルファベット順に表示されない，といった様々なバグが存在する．
これを修正したものをbugfix版として独自に用意している（mdspass2ソースに含めている）
ので，そちらをコンパイルして頂いても良い．

＝＝＝Linux版GLUIのバグとその修正について＝＝＝
（面倒な方は「バグその１・その２」は読まずに「バグその３」へジャンプしてください）
◇GLUIのバグその１◇
システムによっては，ファイルブラウザでダブルクリックが効かないというバグに
遭遇する（example6で，左下のボックスに現れるファイルをダブルクリックしても
右側の窓にファイル内容が表示されない）．
その際は，
src/glui_list.cpp の126行め
  if (last_line == curr_line && (ms - last_click_time) < 300) {
を
  if (last_line == curr_line && (int)(ms - last_click_time) < 300) {
のように修正する必要がある．

◇GLUIのバグその２◇
・ファイルブラウザでディレクトリ変更ができない，
・一番トップに表示されるファイルが選択できない，
というバグに遭遇する（上記と同様，example6でテストされたい）．
その際は，
src/glui_filebrowser.cppの79行め
  if (this_item > 0) { /* file or directory selected */
を
  if (this_item >= 0) { /* file or directory selected */
に，81行め
    if (selected[0] == '/' || selected[0] == '\\') {
を
    if (selected[strlen(selected)-1] == '/' || selected[0] == '\\') {
に，84行め
        chdir(selected+1);
を
        chdir(selected);
に修正する必要がある．

◇GLUIのバグその３◇
ファイルブラウザでファイル名がアルファベット順に表示されず，出鱈目な順序なので
非常に使いにくい．これを修正するには新たな関数を組込むなど比較的大きな改修が
必要であったので，ここでは書ききれない．
mdspass2のディレクトリ以下に
  glui-2.36_bugfix2/
というディレクトリがあるが，そこに修正版のglui一式を入れておいたので，
そこに移動してから上記２）の手順を実行すればよい．
## コンパイル時にundefined reference to symbol 'pthread_cancel@@GLIBC_2.2.5'
## と出る場合にはmakefile内のLIBSに-lpthreadを追加すること。
==============================================================

３）libpngのインストール
libpng と libpng-devel がインストールされている必要があります．
yumの場合
> sudo yum install libpng-devel
aptの場合
> sudo apt install libpng-dev

注）makeの際、環境によっては、-lXmu, -lXiなどがないと言われる。その場合には、
yumの場合
> sudo yum install libXmu-devel
> sudo yum install libXi-devel
apt-getの場合
sudo apt-get install libxmu-dev libxi-dev

４）lapack/blasのインストール
yumの場合
> sudo yum install lapack
> sudo yum install blas
> sudo yum install lapack-devel
apt-getの場合
> sudo apt-get install libatlas-base-dev

<Macの場合> (2020年12月、macOS Big Sur (ver. 11.0.1) でのインストールを確認し、記述を修正しました）

(1)gccのインストール
Xcodeをインストール．Mac App Storeより無料でインストールできる．（その際にMacOSのバージョンをupgradeする必要があるといわれた場合には素直に従ってください）

Command Line Toolsをインストール．Xcodeを開き，File -> Xcode -> Open Developer Tool -> More Developer Tools と選択していき，リストよりCommand Line Toolsを選ぶ（自分の環境にあったバージョンを選択）．

(2)Homebrewのインストール
Homebrewのサイト(https://brew.sh/)に行くと、「以下の行をターミナル上にコピペして実効しろ」とある。
/bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh)"
（実際にサイトに飛んで、コピペして頂いた方が安全と思われる）
途中でEnterキーの入力が促され、さらにパスワードも求められるがあとは自動でインストールされるはず。

ターミナル上で brew doctor と入力してEnterする。
Your system is ready to brew.
と表示されればＯＫ。

※glutを利用したプログラムのコンパイルには，コンパイルオプションとして
-framework OpenGL -framework GLUT -framework Foundation　を付け加える．
たとえば
gcc -framework GLUT -framework OpenGL -framework Foundation main.cpp
などとする。

(3)gluiのインストール
glui はframeworkを使うと上手くいかない（gluiソースに付属のexampleすらコンパイルエラーを吐く）ため，ソースからコンパイルする．
http://glui.sourceforge.net/ などからソース(最新版はglui-2.36.tgz)を入手
makefile を以下のように変更
　CC = g++ -O3
　LIBGL, LIBS, LIBGLUT, CPPFLAGS をコメントアウト
　LIBS = -framework OpenGL -framework GLUT -framework Foundation としておく
make し、lib/libglui.a ，glui.h を所定の位置にコピー．

※gluiの構築については上記のLinuxの場合の説明も参考にしてください．

gluiのexample/にあるサンプルプログラムは、例えば
g++ -framework GLUT -framework OpenGL -lglui example1.cpp
とすればコンパイルできるはずなので、正常に動作するかどうか確認しておく。

(4)libpngのインストール
libpngのソースファイル（例えばlibpng-1.6.34.tar.gz）を探してきてダウンロード．展開してそのディレクトリに移動し，以下のコマンドを実行．
> ./configure
> make
> sudo make install

(5)lapackのインストール
lapackのライブラリが入っていない環境では，lapackをソース（netlibを参照）から取ってきてインストールする必要があります（私の環境ではこの作業は必要なかったのでテストできていません）．

※なおそのためには更にgfortranが必要になりますが、こちらでバイナリが取得できます。MacOSがHigh Sierraの場合でもSierraのものが利用可能なようです。

lapackのソースファイルを展開後、展開したディレクトリに入り、
> cp INSTALL/make.inc.gfortran make.inc
Makefileの11行目を lib: blaslib lapacklib tmglib に書き換え
あとは make でコンパイルできるはずです。

２．mdspass2のコンパイル（Linux, Macとも。Macは下記3.でMakefileの編集が必要）

(1)http://www.cmsm.iis.u-tokyo.ac.jp/code/mdspass2/ より最新のtarball
(mdspass2.日付.tar.gz)をダウンロード （Mac環境ではコンパイル時にエラーが
出るかもしれません．その際はファイル名がforMacとなっているtar.gzファイルを
試してください）

(2)tar xvfz <filename> で展開する

(3)<Macの場合>
Makefile中の CFLAGS = の行を下記のように編集。
CFLAGS = -framework OpenGL -framework GLUT -framework Foundation -llapack -lblas -lglui -lm -I/usr/X11R6/include -lpng -lpthread

(4)make でコンパイル．

(5)./mdspass2 で実行されます．
（注）
　ホームディレクトリを指定したい際には ./mdspass2 <DIR>
　原子配置ファイルを指定したい際には ./mdspass2 <DIR> CONFIG
　原子配置ファイルおよびセッティングファイルを指定したい際には
./mdpass2 <DIR> CONFIG SETDAT
のようにします．
なお，ホームディレクトリ以下に pot/ディレクトリがあり，その下にポテンシャル
データファイルが置かれている必要があります．

